
set nocount on

declare	@transaction_time 	datetime,
	@current_transaction 	int,
	@orders_count 		int,
	@order_details_count 	int,
	@max_orderid 		int

set 	@transaction_time = '1/1/1900 00:30:00'
set 	@transaction_time = getdate() + @transaction_time
set 	@current_transaction = 1

while getdate() <= @transaction_time
begin

	begin tran

		insert into orders(CustomerID, EmployeeID, OrderDate, 
			RequiredDate, ShippedDate, ShipVia, 
			Freight, ShipName, ShipAddress, 
			ShipCity, ShipRegion, ShipPostalCode, ShipCountry)
		select top 10 CustomerID, EmployeeID, OrderDate, RequiredDate, ShippedDate, 
			ShipVia, Freight, ShipName, ShipAddress, ShipCity, 
			ShipRegion, ShipPostalCode, ShipCountry 
		from orders
		where OrderID%(@current_transaction+4) = @current_transaction
	
		set @orders_count = @@rowcount
		set @max_orderid = @@identity
	
		insert into [Order Details](OrderID, ProductID, UnitPrice, Quantity)
		select O.OrderID, P.ProductID, P.UnitPrice, 1
		from Orders O
		left outer join [Order Details] OD
			on O.OrderID = OD.OrderID
		cross join
			(
			select top 2 ProductID, UnitPrice
			from Products
			where ProductID < (@current_transaction*9)%77
			) as P
		where OD.OrderID is null
	
		set @order_details_count = @@rowcount
	
		print 'Current Transaction Count: ' + cast(@current_transaction as varchar(10))
		print 'Added Orders: ' + cast(@orders_count as varchar(10))
		print 'Max Order ID: ' + cast(@max_orderid as varchar(10))
		print 'Added Order Details:' + cast(@order_details_count as varchar(10))
		print ''
	
		set @current_transaction = @current_transaction + 1

	commit tran

	waitfor DELAY '00:00:20'

end

set nocount off

/*
delete from Orders
where OrderID > 11756

USE master
EXEC sp_addumpdevice 'disk', 'NwindLog',
   'c:\NwindLog.trn'

BACKUP LOG Northwind
   TO NwindLog

EXEC sp_dropdevice 'NwindLog','DELFILE'

Use northwind

*/

